Index: branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.cpp	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.cpp	(revision 1200)
@@ -983,25 +1013,22 @@
     else
     {
-#endif
-    if (bRefreshPending==true && pocCurr > pocCRA) // CRA reference marking pending 
-    {
-      TComList<TComPic*>::iterator        iterPic       = rcListPic.begin();
-      while (iterPic != rcListPic.end())
-      {
-        rpcPic = *(iterPic);
-        if (rpcPic->getPOC() != pocCurr && rpcPic->getPOC() != pocCRA)
-        {
-          rpcPic->getSlice(0)->setReferenced(false);
-        }
-        iterPic++;
-      }
-      bRefreshPending = false; 
-    }
-#if EFFICIENT_FIELD_IRAP
-    }
-#endif
+      if (bRefreshPending==true && pocCurr > pocCRA) // CRA reference marking pending
+      {
+        TComList<TComPic*>::iterator iterPic = rcListPic.begin();
+        while (iterPic != rcListPic.end())
+        {
+          rpcPic = *(iterPic);
+          if (rpcPic->getPOC() != pocCurr && rpcPic->getPOC() != pocCRA)
+          {
+            rpcPic->getSlice(0)->setReferenced(false);
+          }
+          iterPic++;
+        }
+        bRefreshPending = false;
+      }
+    }
     if ( getNalUnitType() == NAL_UNIT_CODED_SLICE_CRA ) // CRA picture found
     {
-      bRefreshPending = true; 
+      bRefreshPending = true;
       pocCRA = pocCurr;
     }
@@ -1017,5 +1044,5 @@
   m_iPOC                 = pSrc->m_iPOC;
   m_eNalUnitType         = pSrc->m_eNalUnitType;
-#if H_MV
+#if NH_MV
   m_layerId              = pSrc->m_layerId;
   // GT: Copying of several other values might be be missing here, or is above not necessary? 
@@ -1026,10 +1053,11 @@
   m_iSliceQpBase         = pSrc->m_iSliceQpBase;
 #endif
+  m_ChromaQpAdjEnabled = pSrc->m_ChromaQpAdjEnabled;
   m_deblockingFilterDisable   = pSrc->m_deblockingFilterDisable;
   m_deblockingFilterOverrideFlag = pSrc->m_deblockingFilterOverrideFlag;
   m_deblockingFilterBetaOffsetDiv2 = pSrc->m_deblockingFilterBetaOffsetDiv2;
   m_deblockingFilterTcOffsetDiv2 = pSrc->m_deblockingFilterTcOffsetDiv2;
-  
-  for (i = 0; i < 2; i++)
+
+  for (i = 0; i < NUM_REF_PIC_LIST_01; i++)
   {
     m_aiNumRefIdx[i]     = pSrc->m_aiNumRefIdx[i];
@@ -1039,10 +1067,13 @@
   {
     m_list1IdxToList0Idx[i] = pSrc->m_list1IdxToList0Idx[i];
-  } 
+  }
+
   m_bCheckLDC             = pSrc->m_bCheckLDC;
   m_iSliceQpDelta        = pSrc->m_iSliceQpDelta;
-  m_iSliceQpDeltaCb      = pSrc->m_iSliceQpDeltaCb;
-  m_iSliceQpDeltaCr      = pSrc->m_iSliceQpDeltaCr;
-  for (i = 0; i < 2; i++)
+  for (UInt component = 0; component < MAX_NUM_COMPONENT; component++)
+  {
+    m_iSliceChromaQpDelta[component] = pSrc->m_iSliceChromaQpDelta[component];
+  }
+  for (i = 0; i < NUM_REF_PIC_LIST_01; i++)
   {
     for (j = 0; j < MAX_NUM_REF; j++)
@@ -1050,15 +1081,10 @@
       m_apcRefPicList[i][j]  = pSrc->m_apcRefPicList[i][j];
       m_aiRefPOCList[i][j]   = pSrc->m_aiRefPOCList[i][j];
-#if H_MV
+      m_bIsUsedAsLongTerm[i][j] = pSrc->m_bIsUsedAsLongTerm[i][j];
+#if NH_MV
       m_aiRefLayerIdList[i][j] = pSrc->m_aiRefLayerIdList[i][j];
 #endif
     }
-  }
-  for (i = 0; i < 2; i++)
-  {
-    for (j = 0; j < MAX_NUM_REF + 1; j++)
-    {
-      m_bIsUsedAsLongTerm[i][j] = pSrc->m_bIsUsedAsLongTerm[i][j];
-    }
+    m_bIsUsedAsLongTerm[i][MAX_NUM_REF] = pSrc->m_bIsUsedAsLongTerm[i][MAX_NUM_REF];
   }
   m_iDepth               = pSrc->m_iDepth;
@@ -1068,9 +1094,7 @@
 
   // access channel
-#if H_MV
+#if NH_MV
   m_pcVPS                = pSrc->m_pcVPS;
 #endif
-  m_pcSPS                = pSrc->m_pcSPS;
-  m_pcPPS                = pSrc->m_pcPPS;
   m_pcRPS                = pSrc->m_pcRPS;
   m_iLastIDR             = pSrc->m_iLastIDR;
@@ -1080,6 +1104,8 @@
   m_colFromL0Flag        = pSrc->m_colFromL0Flag;
   m_colRefIdx            = pSrc->m_colRefIdx;
+
   setLambdas(pSrc->getLambdas());
-  for (i = 0; i < 2; i++)
+
+  for (i = 0; i < NUM_REF_PIC_LIST_01; i++)
   {
     for (j = 0; j < MAX_NUM_REF; j++)
@@ -1095,33 +1121,38 @@
   m_bTLayerSwitchingFlag          = pSrc->m_bTLayerSwitchingFlag;
 
-  m_sliceMode                   = pSrc->m_sliceMode;
-  m_sliceArgument               = pSrc->m_sliceArgument;
-  m_sliceCurStartCUAddr         = pSrc->m_sliceCurStartCUAddr;
-  m_sliceCurEndCUAddr           = pSrc->m_sliceCurEndCUAddr;
-  m_sliceIdx                    = pSrc->m_sliceIdx;
-  m_sliceSegmentMode            = pSrc->m_sliceSegmentMode;
-  m_sliceSegmentArgument        = pSrc->m_sliceSegmentArgument; 
-  m_sliceSegmentCurStartCUAddr  = pSrc->m_sliceSegmentCurStartCUAddr;
-  m_sliceSegmentCurEndCUAddr    = pSrc->m_sliceSegmentCurEndCUAddr;
-  m_nextSlice                    = pSrc->m_nextSlice;
-  m_nextSliceSegment             = pSrc->m_nextSliceSegment;
-  for ( Int e=0 ; e<2 ; e++ )
-  {
-    for ( Int n=0 ; n<MAX_NUM_REF ; n++ )
-    {
-      memcpy(m_weightPredTable[e][n], pSrc->m_weightPredTable[e][n], sizeof(wpScalingParam)*3 );
-    }
-  }
-  m_saoEnabledFlag = pSrc->m_saoEnabledFlag; 
-  m_saoEnabledFlagChroma = pSrc->m_saoEnabledFlagChroma;
-  m_cabacInitFlag                = pSrc->m_cabacInitFlag;
-  m_numEntryPointOffsets  = pSrc->m_numEntryPointOffsets;
-
-  m_bLMvdL1Zero = pSrc->m_bLMvdL1Zero;
-  m_LFCrossSliceBoundaryFlag = pSrc->m_LFCrossSliceBoundaryFlag;
+  m_sliceMode                     = pSrc->m_sliceMode;
+  m_sliceArgument                 = pSrc->m_sliceArgument;
+  m_sliceCurStartCtuTsAddr        = pSrc->m_sliceCurStartCtuTsAddr;
+  m_sliceCurEndCtuTsAddr          = pSrc->m_sliceCurEndCtuTsAddr;
+  m_sliceIdx                      = pSrc->m_sliceIdx;
+  m_sliceSegmentMode              = pSrc->m_sliceSegmentMode;
+  m_sliceSegmentArgument          = pSrc->m_sliceSegmentArgument;
+  m_sliceSegmentCurStartCtuTsAddr = pSrc->m_sliceSegmentCurStartCtuTsAddr;
+  m_sliceSegmentCurEndCtuTsAddr   = pSrc->m_sliceSegmentCurEndCtuTsAddr;
+  m_nextSlice                     = pSrc->m_nextSlice;
+  m_nextSliceSegment              = pSrc->m_nextSliceSegment;
+
+  for ( UInt e=0 ; e<NUM_REF_PIC_LIST_01 ; e++ )
+  {
+    for ( UInt n=0 ; n<MAX_NUM_REF ; n++ )
+    {
+      memcpy(m_weightPredTable[e][n], pSrc->m_weightPredTable[e][n], sizeof(WPScalingParam)*MAX_NUM_COMPONENT );
+    }
+  }
+
+  for( UInt ch = 0 ; ch < MAX_NUM_CHANNEL_TYPE; ch++)
+  {
+    m_saoEnabledFlag[ch] = pSrc->m_saoEnabledFlag[ch];
+  }
+
+  m_cabacInitFlag                 = pSrc->m_cabacInitFlag;
+
+  m_bLMvdL1Zero                   = pSrc->m_bLMvdL1Zero;
+  m_LFCrossSliceBoundaryFlag      = pSrc->m_LFCrossSliceBoundaryFlag;
   m_enableTMVPFlag                = pSrc->m_enableTMVPFlag;
   m_maxNumMergeCand               = pSrc->m_maxNumMergeCand;
-
-#if H_MV
+  m_encCABACTableIdx              = pSrc->m_encCABACTableIdx;
+
+#if NH_MV
   // Additional slice header syntax elements 
 #if !H_MV_HLS7_GEN
@@ -1144,12 +1175,12 @@
   m_icSkipParseFlag = pSrc->m_icSkipParseFlag;
 #endif
-}
-
-Int TComSlice::m_prevTid0POC = 0;
+
+}
+
 
 /** Function for setting the slice's temporal layer ID and corresponding temporal_layer_switching_point_flag.
  * \param uiTLayer Temporal layer ID of the current slice
- * The decoder calls this function to set temporal_layer_switching_point_flag for each temporal layer based on 
- * the SPS's temporal_id_nesting_flag and the parsed PPS.  Then, current slice's temporal layer ID and 
+ * The decoder calls this function to set temporal_layer_switching_point_flag for each temporal layer based on
+ * the SPS's temporal_id_nesting_flag and the parsed PPS.  Then, current slice's temporal layer ID and
  * temporal_layer_switching_point_flag is set accordingly.
  */
@@ -1161,5 +1192,5 @@
 /** Function for checking if this is a switching-point
 */
-Bool TComSlice::isTemporalLayerSwitchingPoint( TComList<TComPic*>& rcListPic )
+Bool TComSlice::isTemporalLayerSwitchingPoint(TComList<TComPic*>& rcListPic)
 {
   TComPic* rpcPic;
@@ -1180,23 +1211,23 @@
 }
 
-/** Function for checking if this is a STSA candidate 
+/** Function for checking if this is a STSA candidate
  */
-Bool TComSlice::isStepwiseTemporalLayerSwitchingPointCandidate( TComList<TComPic*>& rcListPic )
-{
-    TComPic* rpcPic;
-    
-    TComList<TComPic*>::iterator iterPic = rcListPic.begin();
-    while ( iterPic != rcListPic.end())
-    {
-        rpcPic = *(iterPic++);
-        if(rpcPic->getSlice(0)->isReferenced() &&  (rpcPic->getUsedByCurr()==true) && rpcPic->getPOC() != getPOC())
-        {
-            if(rpcPic->getTLayer() >= getTLayer())
-            {
-                return false;
-            }
-        }
-    }
-    return true;
+Bool TComSlice::isStepwiseTemporalLayerSwitchingPointCandidate(TComList<TComPic*>& rcListPic)
+{
+  TComPic* rpcPic;
+
+  TComList<TComPic*>::iterator iterPic = rcListPic.begin();
+  while ( iterPic != rcListPic.end())
+  {
+    rpcPic = *(iterPic++);
+    if(rpcPic->getSlice(0)->isReferenced() &&  (rpcPic->getUsedByCurr()==true) && rpcPic->getPOC() != getPOC())
+    {
+      if(rpcPic->getTLayer() >= getTLayer())
+      {
+        return false;
+      }
+    }
+  }
+  return true;
 }
 
@@ -1264,10 +1295,8 @@
   {
     rpcPic = *(iterPic++);
-#if BUGFIX_INTRAPERIOD
     if(!rpcPic->getReconMark())
     {
       continue;
     }
-#endif
     if (rpcPic->getPOC() == this->getPOC())
     {
@@ -1278,9 +1307,5 @@
     // in decoding order shall precede the IRAP picture in output order.
     // (Note that any picture following in output order would be present in the DPB)
-#if !SETTING_NO_OUT_PIC_PRIOR
-    if(rpcPic->getSlice(0)->getPicOutputFlag() == 1)
-#else
     if(rpcPic->getSlice(0)->getPicOutputFlag() == 1 && !this->getNoOutputPriorPicsFlag())
-#endif
     {
       if(nalUnitType == NAL_UNIT_CODED_SLICE_BLA_N_LP    ||
@@ -1317,16 +1342,16 @@
     // When a picture is a leading picture, it shall precede, in decoding order,
     // all trailing pictures that are associated with the same IRAP picture.
-    if(nalUnitType == NAL_UNIT_CODED_SLICE_RASL_N ||
-       nalUnitType == NAL_UNIT_CODED_SLICE_RASL_R ||
-       nalUnitType == NAL_UNIT_CODED_SLICE_RADL_N ||
-       nalUnitType == NAL_UNIT_CODED_SLICE_RADL_R)
-    {
-      if(rpcPic->getSlice(0)->getAssociatedIRAPPOC() == this->getAssociatedIRAPPOC())
-      {
-        // rpcPic is a picture that preceded the leading in decoding order since it exist in the DPB
-        // rpcPic would violate the constraint if it was a trailing picture
-        assert(rpcPic->getPOC() <= this->getAssociatedIRAPPOC());
-      }
-    }
+      if(nalUnitType == NAL_UNIT_CODED_SLICE_RASL_N ||
+         nalUnitType == NAL_UNIT_CODED_SLICE_RASL_R ||
+         nalUnitType == NAL_UNIT_CODED_SLICE_RADL_N ||
+         nalUnitType == NAL_UNIT_CODED_SLICE_RADL_R)
+      {
+        if(rpcPic->getSlice(0)->getAssociatedIRAPPOC() == this->getAssociatedIRAPPOC())
+        {
+          // rpcPic is a picture that preceded the leading in decoding order since it exist in the DPB
+          // rpcPic would violate the constraint if it was a trailing picture
+          assert(rpcPic->getPOC() <= this->getAssociatedIRAPPOC());
+        }
+      }
 
     // Any RASL picture associated with a CRA or BLA picture shall precede any
@@ -1334,5 +1359,5 @@
     if(nalUnitType == NAL_UNIT_CODED_SLICE_RASL_N ||
        nalUnitType == NAL_UNIT_CODED_SLICE_RASL_R)
-    { 
+    {
       if((this->getAssociatedIRAPType() == NAL_UNIT_CODED_SLICE_BLA_N_LP   ||
           this->getAssociatedIRAPType() == NAL_UNIT_CODED_SLICE_BLA_W_LP   ||
@@ -1372,7 +1397,8 @@
 
 
+
 /** Function for applying picture marking based on the Reference Picture Set in pReferencePictureSet.
 */
-Void TComSlice::applyReferencePictureSet( TComList<TComPic*>& rcListPic, TComReferencePictureSet *pReferencePictureSet)
+Void TComSlice::applyReferencePictureSet( TComList<TComPic*>& rcListPic, const TComReferencePictureSet *pReferencePictureSet)
 {
   TComPic* rpcPic;
@@ -1414,5 +1440,5 @@
         }
       }
-      else 
+      else
       {
         Int pocCycle = 1<<rpcPic->getPicSym()->getSlice(0)->getSPS()->getBitsForPOC();
@@ -1427,5 +1453,5 @@
 
     }
-#if H_MV
+#if NH_MV
     if( isReference ) // Current picture is in the temporal RPS
     {
@@ -1435,7 +1461,7 @@
     // mark the picture as "unused for reference" if it is not in
     // the Reference Picture Set
-    if(rpcPic->getPicSym()->getSlice(0)->getPOC() != this->getPOC() && isReference == 0)    
-    {            
-      rpcPic->getSlice( 0 )->setReferenced( false );   
+    if(rpcPic->getPicSym()->getSlice(0)->getPOC() != this->getPOC() && isReference == 0)
+    {
+      rpcPic->getSlice( 0 )->setReferenced( false );
       rpcPic->setUsedByCurr(0);
       rpcPic->setIsLongTerm(0);
@@ -1458,14 +1484,8 @@
 /** Function for applying picture marking based on the Reference Picture Set in pReferencePictureSet.
 */
-#if ALLOW_RECOVERY_POINT_AS_RAP
-Int TComSlice::checkThatAllRefPicsAreAvailable( TComList<TComPic*>& rcListPic, TComReferencePictureSet *pReferencePictureSet, Bool printErrors, Int pocRandomAccess, Bool bUseRecoveryPoint)
-#else
-Int TComSlice::checkThatAllRefPicsAreAvailable( TComList<TComPic*>& rcListPic, TComReferencePictureSet *pReferencePictureSet, Bool printErrors, Int pocRandomAccess)
-#endif
-{
-#if ALLOW_RECOVERY_POINT_AS_RAP
+Int TComSlice::checkThatAllRefPicsAreAvailable( TComList<TComPic*>& rcListPic, const TComReferencePictureSet *pReferencePictureSet, Bool printErrors, Int pocRandomAccess, Bool bUseRecoveryPoint)
+{
   Int atLeastOneUnabledByRecoveryPoint = 0;
   Int atLeastOneFlushedByPreviousIDR = 0;
-#endif
   TComPic* rpcPic;
   Int i, isAvailable;
@@ -1488,5 +1508,4 @@
         if(rpcPic->getIsLongTerm() && (rpcPic->getPicSym()->getSlice(0)->getPOC()) == pReferencePictureSet->getPOC(i) && rpcPic->getSlice(0)->isReferenced())
         {
-#if ALLOW_RECOVERY_POINT_AS_RAP
           if(bUseRecoveryPoint && this->getPOC() > pocRandomAccess && this->getPOC() + pReferencePictureSet->getDeltaPOC(i) < pocRandomAccess)
           {
@@ -1495,12 +1514,9 @@
           else
           {
-          isAvailable = 1;
-        }
-#else
-          isAvailable = 1;
-#endif
-        }
-      }
-      else 
+            isAvailable = 1;
+          }
+        }
+      }
+      else
       {
         Int pocCycle = 1<<rpcPic->getPicSym()->getSlice(0)->getSPS()->getBitsForPOC();
@@ -1509,5 +1525,4 @@
         if(rpcPic->getIsLongTerm() && curPoc == refPoc && rpcPic->getSlice(0)->isReferenced())
         {
-#if ALLOW_RECOVERY_POINT_AS_RAP
           if(bUseRecoveryPoint && this->getPOC() > pocRandomAccess && this->getPOC() + pReferencePictureSet->getDeltaPOC(i) < pocRandomAccess)
           {
@@ -1516,9 +1531,6 @@
           else
           {
-          isAvailable = 1;
-        }
-#else
-          isAvailable = 1;
-#endif
+            isAvailable = 1;
+          }
         }
       }
@@ -1540,8 +1552,7 @@
           refPoc = refPoc & (pocCycle - 1);
         }
-        
+
         if (rpcPic->getSlice(0)->isReferenced() && curPoc == refPoc)
         {
-#if ALLOW_RECOVERY_POINT_AS_RAP
           if(bUseRecoveryPoint && this->getPOC() > pocRandomAccess && this->getPOC() + pReferencePictureSet->getDeltaPOC(i) < pocRandomAccess)
           {
@@ -1550,13 +1561,8 @@
           else
           {
-          isAvailable = 1;
-          rpcPic->setIsLongTerm(1);
-          break;
-        }
-#else
-          isAvailable = 1;
-          rpcPic->setIsLongTerm(1);
-          break;
-#endif
+            isAvailable = 1;
+            rpcPic->setIsLongTerm(1);
+            break;
+          }
         }
       }
@@ -1564,6 +1570,6 @@
     // report that a picture is lost if it is in the Reference Picture Set
     // but not available as reference picture
-    if(isAvailable == 0)    
-    {            
+    if(isAvailable == 0)
+    {
       if (this->getPOC() + pReferencePictureSet->getDeltaPOC(i) >= pocRandomAccess)
       {
@@ -1586,5 +1592,4 @@
         }
       }
-#if ALLOW_RECOVERY_POINT_AS_RAP
       else if(bUseRecoveryPoint && this->getPOC() > pocRandomAccess)
       {
@@ -1595,7 +1600,6 @@
         atLeastOneFlushedByPreviousIDR = 1;
       }
-#endif
-    }
-  }  
+    }
+  }
   // loop through all short-term pictures in the Reference Picture Set
   // to see if the picture should be kept as reference picture
@@ -1611,5 +1615,4 @@
       if(!rpcPic->getIsLongTerm() && rpcPic->getPicSym()->getSlice(0)->getPOC() == this->getPOC() + pReferencePictureSet->getDeltaPOC(i) && rpcPic->getSlice(0)->isReferenced())
       {
-#if ALLOW_RECOVERY_POINT_AS_RAP
         if(bUseRecoveryPoint && this->getPOC() > pocRandomAccess && this->getPOC() + pReferencePictureSet->getDeltaPOC(i) < pocRandomAccess)
         {
@@ -1618,15 +1621,12 @@
         else
         {
-        isAvailable = 1;
-      }
-#else
-        isAvailable = 1;
-#endif
+          isAvailable = 1;
+        }
       }
     }
     // report that a picture is lost if it is in the Reference Picture Set
     // but not available as reference picture
-    if(isAvailable == 0)    
-    {            
+    if(isAvailable == 0)
+    {
       if (this->getPOC() + pReferencePictureSet->getDeltaPOC(i) >= pocRandomAccess)
       {
@@ -1649,22 +1649,19 @@
         }
       }
-#if ALLOW_RECOVERY_POINT_AS_RAP
       else if(bUseRecoveryPoint && this->getPOC() > pocRandomAccess)
       {
         atLeastOneUnabledByRecoveryPoint = 1;
-    }
+      }
       else if(bUseRecoveryPoint && (this->getAssociatedIRAPType()==NAL_UNIT_CODED_SLICE_IDR_N_LP || this->getAssociatedIRAPType()==NAL_UNIT_CODED_SLICE_IDR_W_RADL))
       {
         atLeastOneFlushedByPreviousIDR = 1;
-  }    
-#endif
-    }
-    }
-#if ALLOW_RECOVERY_POINT_AS_RAP
+      }
+    }
+  }
+
   if(atLeastOneUnabledByRecoveryPoint || atLeastOneFlushedByPreviousIDR)
   {
     return -1;
   }    
-#endif
   if(atLeastOneLost)
   {
@@ -1683,9 +1680,5 @@
 /** Function for constructing an explicit Reference Picture Set out of the available pictures in a referenced Reference Picture Set
 */
-#if ALLOW_RECOVERY_POINT_AS_RAP
-Void TComSlice::createExplicitReferencePictureSetFromReference( TComList<TComPic*>& rcListPic, TComReferencePictureSet *pReferencePictureSet, Bool isRAP, Int pocRandomAccess, Bool bUseRecoveryPoint)
-#else
-Void TComSlice::createExplicitReferencePictureSetFromReference( TComList<TComPic*>& rcListPic, TComReferencePictureSet *pReferencePictureSet, Bool isRAP)
-#endif
+Void TComSlice::createExplicitReferencePictureSetFromReference( TComList<TComPic*>& rcListPic, const TComReferencePictureSet *pReferencePictureSet, Bool isRAP, Int pocRandomAccess, Bool bUseRecoveryPoint, const Bool bEfficientFieldIRAPEnabled)
 {
   TComPic* rpcPic;
@@ -1695,4 +1688,5 @@
   Int nrOfPositivePictures = 0;
   TComReferencePictureSet* pcRPS = this->getLocalRPS();
+  Bool irapIsInRPS = false; // Used when bEfficientFieldIRAPEnabled==true
 
   // loop through all pictures in the Reference Picture Set
@@ -1713,7 +1707,9 @@
         pcRPS->setDeltaPOC(k, pReferencePictureSet->getDeltaPOC(i));
         pcRPS->setUsed(k, pReferencePictureSet->getUsed(i) && (!isRAP));
-#if ALLOW_RECOVERY_POINT_AS_RAP
+        if (bEfficientFieldIRAPEnabled)
+        {
         pcRPS->setUsed(k, pcRPS->getUsed(k) && !(bUseRecoveryPoint && this->getPOC() > pocRandomAccess && this->getPOC() + pReferencePictureSet->getDeltaPOC(i) < pocRandomAccess) ); 
-#endif
+        }
+
         if(pcRPS->getDeltaPOC(k) < 0)
         {
@@ -1722,4 +1718,8 @@
         else
         {
+          if(bEfficientFieldIRAPEnabled && rpcPic->getPicSym()->getSlice(0)->getPOC() == this->getAssociatedIRAPPOC() && this->getAssociatedIRAPPOC() == this->getPOC()+1)
+          {
+            irapIsInRPS = true;
+          }
           nrOfPositivePictures++;
         }
@@ -1728,8 +1728,8 @@
     }
   }
-#if EFFICIENT_FIELD_IRAP
+
   Bool useNewRPS = false;
   // if current picture is complimentary field associated to IRAP, add the IRAP to its RPS. 
-  if(m_pcPic->isField())
+  if(bEfficientFieldIRAPEnabled && m_pcPic->isField() && !irapIsInRPS)
   {
     TComList<TComPic*>::iterator iterPic = rcListPic.begin();
@@ -1747,16 +1747,11 @@
     }
   }
-#endif
   pcRPS->setNumberOfNegativePictures(nrOfNegativePictures);
   pcRPS->setNumberOfPositivePictures(nrOfPositivePictures);
   pcRPS->setNumberOfPictures(nrOfNegativePictures+nrOfPositivePictures);
-  // This is a simplistic inter rps example. A smarter encoder will look for a better reference RPS to do the 
+  // This is a simplistic inter rps example. A smarter encoder will look for a better reference RPS to do the
   // inter RPS prediction with.  Here we just use the reference used by pReferencePictureSet.
   // If pReferencePictureSet is not inter_RPS_predicted, then inter_RPS_prediction is for the current RPS also disabled.
-  if (!pReferencePictureSet->getInterRPSPrediction()
-#if EFFICIENT_FIELD_IRAP
-    || useNewRPS
-#endif
-    )
+  if (!pReferencePictureSet->getInterRPSPrediction() || useNewRPS )
   {
     pcRPS->setInterRPSPrediction(false);
@@ -1767,8 +1762,8 @@
     Int rIdx =  this->getRPSidx() - pReferencePictureSet->getDeltaRIdxMinus1() - 1;
     Int deltaRPS = pReferencePictureSet->getDeltaRPS();
-    TComReferencePictureSet* pcRefRPS = this->getSPS()->getRPSList()->getReferencePictureSet(rIdx);
+    const TComReferencePictureSet* pcRefRPS = this->getSPS()->getRPSList()->getReferencePictureSet(rIdx);
     Int iRefPics = pcRefRPS->getNumberOfPictures();
     Int iNewIdc=0;
-    for(i=0; i<= iRefPics; i++) 
+    for(i=0; i<= iRefPics; i++)
     {
       Int deltaPOC = ((i != iRefPics)? pcRefRPS->getDeltaPOC(i) : 0);  // check if the reference abs POC is >= 0
@@ -1793,5 +1788,5 @@
     pcRPS->setInterRPSPrediction(true);
     pcRPS->setNumRefIdc(iNewIdc);
-    pcRPS->setDeltaRPS(deltaRPS); 
+    pcRPS->setDeltaRPS(deltaRPS);
     pcRPS->setDeltaRIdxMinus1(pReferencePictureSet->getDeltaRIdxMinus1() + this->getSPS()->getRPSList()->getNumberOfReferencePictureSets() - this->getRPSidx());
   }
@@ -1801,19 +1796,14 @@
 }
 
-/** get AC and DC values for weighted pred
- * \param *wp
- * \returns Void
- */
-Void  TComSlice::getWpAcDcParam(wpACDCParam *&wp)
+//! get AC and DC values for weighted pred
+Void  TComSlice::getWpAcDcParam(WPACDCParam *&wp)
 {
   wp = m_weightACDCParam;
 }
 
-/** init AC and DC values for weighted pred
- * \returns Void
- */
+//! init AC and DC values for weighted pred
 Void  TComSlice::initWpAcDcParam()
 {
-  for(Int iComp = 0; iComp < 3; iComp++ )
+  for(Int iComp = 0; iComp < MAX_NUM_COMPONENT; iComp++ )
   {
     m_weightACDCParam[iComp].iAC = 0;
@@ -1822,28 +1812,21 @@
 }
 
-/** get WP tables for weighted pred
- * \param RefPicList
- * \param iRefIdx
- * \param *&wpScalingParam
- * \returns Void
- */
-Void  TComSlice::getWpScaling( RefPicList e, Int iRefIdx, wpScalingParam *&wp )
-{
+//! get tables for weighted prediction
+Void  TComSlice::getWpScaling( RefPicList e, Int iRefIdx, WPScalingParam *&wp )
+{
+  assert (e<NUM_REF_PIC_LIST_01);
   wp = m_weightPredTable[e][iRefIdx];
 }
 
-/** reset Default WP tables settings : no weight. 
- * \param wpScalingParam
- * \returns Void
- */
+//! reset Default WP tables settings : no weight.
 Void  TComSlice::resetWpScaling()
 {
-  for ( Int e=0 ; e<2 ; e++ )
+  for ( Int e=0 ; e<NUM_REF_PIC_LIST_01 ; e++ )
   {
     for ( Int i=0 ; i<MAX_NUM_REF ; i++ )
     {
-      for ( Int yuv=0 ; yuv<3 ; yuv++ )
-      {
-        wpScalingParam  *pwp = &(m_weightPredTable[e][i][yuv]);
+      for ( Int yuv=0 ; yuv<MAX_NUM_COMPONENT ; yuv++ )
+      {
+        WPScalingParam  *pwp = &(m_weightPredTable[e][i][yuv]);
         pwp->bPresentFlag      = false;
         pwp->uiLog2WeightDenom = 0;
@@ -1856,17 +1839,16 @@
 }
 
-/** init WP table
- * \returns Void
- */
-Void  TComSlice::initWpScaling()
-{
-  for ( Int e=0 ; e<2 ; e++ )
+//! init WP table
+Void  TComSlice::initWpScaling(const TComSPS *sps)
+{
+  const Bool bUseHighPrecisionPredictionWeighting = sps->getSpsRangeExtension().getHighPrecisionOffsetsEnabledFlag();
+  for ( Int e=0 ; e<NUM_REF_PIC_LIST_01 ; e++ )
   {
     for ( Int i=0 ; i<MAX_NUM_REF ; i++ )
     {
-      for ( Int yuv=0 ; yuv<3 ; yuv++ )
-      {
-        wpScalingParam  *pwp = &(m_weightPredTable[e][i][yuv]);
-        if ( !pwp->bPresentFlag ) 
+      for ( Int yuv=0 ; yuv<MAX_NUM_COMPONENT ; yuv++ )
+      {
+        WPScalingParam  *pwp = &(m_weightPredTable[e][i][yuv]);
+        if ( !pwp->bPresentFlag )
         {
           // Inferring values not present :
@@ -1875,7 +1857,8 @@
         }
 
+        const Int offsetScalingFactor = bUseHighPrecisionPredictionWeighting ? 1 : (1 << (sps->getBitDepth(toChannelType(ComponentID(yuv)))-8));
+
         pwp->w      = pwp->iWeight;
-        Int bitDepth = yuv ? g_bitDepthC : g_bitDepthY;
-        pwp->o      = pwp->iOffset << (bitDepth-8);
+        pwp->o      = pwp->iOffset * offsetScalingFactor; //NOTE: This value of the ".o" variable is never used - .o is set immediately before it gets used
         pwp->shift  = pwp->uiLog2WeightDenom;
         pwp->round  = (pwp->uiLog2WeightDenom>=1) ? (1 << (pwp->uiLog2WeightDenom-1)) : (0);
@@ -1891,5 +1874,5 @@
 : m_VPSId                     (  0)
 , m_uiMaxTLayers              (  1)
-#if H_MV
+#if NH_MV
 , m_uiMaxLayersMinus1         (  0)
 #else
@@ -1898,18 +1881,14 @@
 , m_bTemporalIdNestingFlag    (false)
 , m_numHrdParameters          (  0)
-#if H_MV
+#if NH_MV
 , m_maxLayerId             (  0)
 #else
 , m_maxNuhReservedZeroLayerId (  0)
 #endif
-, m_hrdParameters             (NULL)
-, m_hrdOpSetIdx               (NULL)
-, m_cprmsPresentFlag          (NULL)
-#if H_MV
-, m_dpbSize                   (NULL)
-, m_vpsVUI                 (  NULL )
-#endif
-{
-#if H_MV
+, m_hrdParameters             ()
+, m_hrdOpSetIdx               ()
+, m_cprmsPresentFlag          ()
+{
+#if NH_MV
   m_vpsBaseLayerInternalFlag = true; 
   m_vpsBaseLayerAvailableFlag = true; 
@@ -1922,8 +1901,8 @@
   {
     m_numReorderPics[i] = 0;
-    m_uiMaxDecPicBuffering[i] = 1; 
+    m_uiMaxDecPicBuffering[i] = 1;
     m_uiMaxLatencyIncrease[i] = 0;
   }
-#if H_MV
+#if NH_MV
   for (Int lsIdx = 0; lsIdx < MAX_VPS_OP_SETS_PLUS1; lsIdx++ )
   {  
@@ -1988,13 +1967,12 @@
     m_layerIdInNuh      [i] = ( i == 0 ) ? 0 : -1; 
     m_numDirectRefLayers[i] = 0; 
-#if H_3D
+#if NH_3D
     m_numRefListLayers[i] = 0; 
 #endif
     m_vpsRepFormatIdx    [i] = 0; 
-    m_pocLsbNotPresentFlag[i] = 0;
-    m_repFormat          [i] = NULL; 
+    m_pocLsbNotPresentFlag[i] = 0;    
     m_viewIdVal          [i] = 0; 
 
-#if H_3D
+#if NH_3D
     m_viewIndex         [i] = -1; 
 #endif
@@ -2006,5 +1984,5 @@
       m_dependencyFlag  [i][j]    = false; 
       m_idDirectRefLayer[i][j]    = -1; 
-#if H_3D
+#if NH_3D
       m_idRefListLayer[i][j]    = -1; 
 #endif
@@ -2020,9 +1998,5 @@
 #if H_3D_ARP
 #endif
-  }
-  m_vpsVUI = new TComVPSVUI; 
-  m_dpbSize = new TComDpbSize; 
-
-
+  }  
 #endif
 }
@@ -2030,22 +2004,7 @@
 TComVPS::~TComVPS()
 {
-  if( m_hrdParameters    != NULL )     delete[] m_hrdParameters;
-  if( m_hrdOpSetIdx      != NULL )     delete[] m_hrdOpSetIdx;
-  if( m_cprmsPresentFlag != NULL )     delete[] m_cprmsPresentFlag;
-#if H_MV
-  if ( m_vpsVUI          != NULL )     delete m_vpsVUI; 
-  if ( m_dpbSize         != NULL )     delete m_dpbSize; 
-
-  for( Int i = 0; i < MAX_NUM_LAYERS; i++ )
-  {
-    if (m_repFormat[ i ] != NULL )      delete m_repFormat[ i ];    
-  }
-#endif
-#if H_3D
-  deleteCamPars();
-#endif
-}
-
-#if H_MV
+}
+
+#if NH_MV
 
 Bool TComVPS::checkVPSExtensionSyntax()
@@ -2066,10 +2025,10 @@
 }
 
-Int TComVPS::getNumScalabilityTypes()
+Int TComVPS::getNumScalabilityTypes() const
 {
   return scalTypeToScalIdx( ScalabilityType(MAX_NUM_SCALABILITY_TYPES) );
 }
 
-Int TComVPS::scalTypeToScalIdx( ScalabilityType scalType )
+Int TComVPS::scalTypeToScalIdx( ScalabilityType scalType ) const
 {
   assert( scalType >= 0 && scalType <= MAX_NUM_SCALABILITY_TYPES ); 
@@ -2114,5 +2073,5 @@
     Int iNuhLId = getLayerIdInNuh( i );
     Int d = 0;
-#if H_3D
+#if NH_3D
     Int l = 0; 
 #endif
@@ -2127,5 +2086,5 @@
         m_idDirectRefLayer[iNuhLId][d++] = jNuhLid;
       }
-#if H_3D
+#if NH_3D
       if( getDirectDependencyFlag( i , j ) && ( getDepthId( iNuhLId ) == getDepthId( jNuhLid ) ))
       {
@@ -2144,5 +2103,5 @@
     }
     m_numDirectRefLayers[ iNuhLId ] = d;
-#if H_3D
+#if NH_3D
     m_numRefListLayers[ iNuhLId ] = l; 
 #endif
@@ -2185,7 +2144,6 @@
 {
   m_numViews = 1; 
-#if H_3D
-  AOF( m_viewOIdxList.size() == 0 ); 
-  
+#if NH_3D
+  AOF( m_viewOIdxList.size() == 0 );   
   m_viewOIdxList.push_back( 0 );        
 #endif
@@ -2207,5 +2165,5 @@
       {
         m_numViews++;
-#if H_3D
+#if NH_3D
         m_viewOIdxList.push_back( getViewOrderIdx( lId ) );        
 #endif
@@ -2216,11 +2174,11 @@
 
 
-Int TComVPS::getScalabilityId( Int layerIdInVps, ScalabilityType scalType )
+Int TComVPS::getScalabilityId( Int layerIdInVps, ScalabilityType scalType ) const
 {
   return getScalabilityMaskFlag( scalType ) ? getDimensionId( layerIdInVps, scalTypeToScalIdx( scalType ) ) : 0;
 }
 
-#if H_3D
-Int TComVPS::getLayerIdInNuh( Int viewIndex, Bool depthFlag )
+#if NH_3D
+Int TComVPS::getLayerIdInNuh( Int viewIndex, Bool depthFlag ) const
 {
   Int foundLayerIdinNuh = -1; 
@@ -2240,37 +2198,34 @@
 Void TComVPS::createCamPars(Int iNumViews)
 {
-  Int i = 0, j = 0;
-
-  m_numCp    = new Int [ iNumViews ];
-  m_cpRefVoi = new Int*[ iNumViews ];
-  m_cpInSliceSegmentHeaderFlag = new Bool[ iNumViews ];
-
-  m_cpPresentFlag  = new Bool*[ iNumViews ]; 
-  
-
-  m_aaaiCodedScale = new Int**[ iNumViews ];
-  m_aaaiCodedOffset = new Int**[ iNumViews ];
-  for ( i = 0; i < iNumViews ; i++ )
-  {
-    m_cpInSliceSegmentHeaderFlag[i] = false;     
-    
-    m_aaaiCodedScale[i] = new Int*[ 2 ];
-    m_aaaiCodedOffset[i] = new Int*[ 2 ];
-
-    m_numCp   [i] = 0; 
-    m_cpRefVoi[i] = new Int[ iNumViews ];
-    m_cpPresentFlag[i] = new Bool[ iNumViews ]; 
-    for ( j = 0; j < iNumViews; j++)
-    {
-      m_cpRefVoi[i][j] = 0; 
-      m_cpPresentFlag[i][j] = false; 
-    }
-    for ( j = 0; j < 2; j++ )
-    {
-      m_aaaiCodedScale[i][j] = new Int[ MAX_NUM_LAYERS ];
-      m_aaaiCodedOffset[i][j] = new Int[ MAX_NUM_LAYERS ];
+  m_numCp                     .resize( iNumViews );
+  m_cpRefVoi                  .resize( iNumViews );
+  m_cpInSliceSegmentHeaderFlag.resize( iNumViews );
+  m_cpPresentFlag             .resize( iNumViews ); 
+  m_aaaiCodedScale            .resize( iNumViews ); 
+  m_aaaiCodedOffset           .resize( iNumViews ); 
+
+  for ( Int i = 0; i < iNumViews ; i++ )
+  {
+    m_numCp                     [i] = 0; 
+    m_cpRefVoi                  [i].resize( iNumViews );
+    m_cpInSliceSegmentHeaderFlag[i] = false;         
+    m_aaaiCodedScale            [i].resize( 2 );
+    m_aaaiCodedOffset           [i].resize( 2 );        
+    m_cpPresentFlag             [i].resize( iNumViews ); 
+
+    for ( Int j = 0; j < iNumViews; j++)
+    {
+      m_cpRefVoi             [i][j] = 0; 
+      m_cpPresentFlag        [i][j] = false; 
+    }
+
+    for ( Int j = 0; j < 2; j++ )
+    {
+      m_aaaiCodedScale       [i][j].resize( MAX_NUM_LAYERS );
+      m_aaaiCodedOffset      [i][j].resize( MAX_NUM_LAYERS );
+
       for ( Int k = 0; k < MAX_NUM_LAYERS; k++ )
       {
-        m_aaaiCodedScale[i][j][k] = 0;
+        m_aaaiCodedScale [i][j][k] = 0;
         m_aaaiCodedOffset[i][j][k] = 0;
       }
